# 4. Prototyping                 

What would I do:         

1. An electronic compost thermometre to tell you when the compost has been correctly heated for pathogen reduction.

2. A little composting bucket compatible with vermicomposting.

3. A kind of Norwegian kettle for the thermophilic compost phase.

## Table of contents:       

[1.The compost thermometre](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#1the-compost-thermometre)            
[1.1.Electronical components](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#11electronical-components)        
[1.2.Circuit](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#12circuit)       
[1.3.Code](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#13code)                          
[1.4.Creation process](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#14creation-process)                  

[2.Transforming a simple bucket into a composting bucket](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#2transforming-a-simple-bucket-into-a-composting-bucket)           
[2.1.Materials](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#21materials)           
[2.2.Instructions](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#22instructions)         
[2.3.Now what ?](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#23now-what-)                    
[2.4.Creation process](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#24creation-process)             
[2.4.1.A Complete stand ?](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#241a-complete-stand)                
[2.4.2.The adaptor](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#242the-adaptor)          
[2.4.3.The slope](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#243the-slope)                 
[2.4.4.The holes disc](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#244the-holes-disc)             
[2.4.5.The taps](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#245the-taps)          
[2.4.6.The little tap](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#246the-little-tap)                   

[3.The simple Norwegian kettle](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#3the-simple-norwegian-kettle)            
[3.1.Materials](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#31materials)            
[3.2.Instructions](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#32instructions)           
[3.3.Result](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/4.Prototyping/#33result)            

## 1.The compost thermometre              
In his book Joseph Jenkins talks about compost thermometre to objectively measure the compost temperature but it is not compulsory in his system. In my system, I need to know if the thermophilic phase reached good temperatures for a good amount of time and when the thermophilic phase is done. A thermometre is thus a good idea.

### 1.1.Electronical components               
A finished product should have a switch, batteries and a display for the temperature. The thermometre takes the temperature every 10 seconds: it is in sleep mode for 8 seconds and awake for 2 seconds. This technic increase the battery live. A rechargeable 9V battery would be better to not throw away the battery once dead.                                 
It is also possible to connect the thermometre on power using the USB cable and an USB adaptor.

I lost one recipe so the prices are more or less estimated but the total is correct.

You can ask your FabLab where to find those components. Maybe they will command them for you.

* 1 DFRduino Uno R3: 23€88

* 1 USB Cable male A and male B: 2€98

* 3 yellow LED: 1€24                
  Update: no yellow LEDs

* 1 green LED: 1€42              
  Update: 3 green LEDs would be 4€26 (weirdly ore expensive than the yellow ones)

* 1 red LED: 1€43

* 5 resistor 220R: 0€85             
  Update: 4 resistors instead would be 0€68

* 1 breadboard: 9€99

* 1 waterproof DS18B20 Temperature Sensor: 10€66            
  The [DS18B20 temperature sensor fact sheet](https://www.velleman.eu/products/view/?id=439184 ): ± 0.5 °C between -10°C and 85°C

* 1 TM1637 4-Digit 7-Segment Display: 4€92

* 19 Jumper Cables M/M: 3€68 for 65

If you want to use a battery:

* 1 switch: from the FabLab

* 1 9V battery holder: 2€50

* 1 non rechargeable 9V battery: 5€95


+9€97 VAT

TOTAL: 78€74


### 1.2.Circuit
I used [Cirkit Designer](https://www.cirkitstudio.com/download.html) to draw the uncomplete circuit: it lacks the temperature sensor, the display, the switch and the cable between the 2 sides of the large breadboard for the ground.                
Each LED needs to be connected to the ground and to a 220R resistor at their positive side as showed on the first sheet.             
The temperature sensor and the display are connected to the ground, to the 5V and to their respective pins.  
Fix the switch to the battery holder on the red side then link the switch to the Vin pin.

![circuit sheet](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/new_circuit.jpg)

![first sheet](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/sheet1.jpg)

![circuit picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/real_thermometre.jpg)

**Update**: the 9V battery dropped dead after something like 12 hours so I switched on sector using the USB cable and a basic phone charger base (anything that convert the USB into an electrical socket).               
I do not know why that happen.

### 1.3.Code
For the code to work you need to download some libraries:

* DallasTemperature and OneWire are for the temperature sensor: both can be downloaded on the Library Manager of the Arduino IDE.

* TM1637Display is for the display: you can download a ZIP file [here](https://github.com/avishorp/TM1637).

* LowPower is for the sleep mode: you can download a ZIP file [here](https://github.com/rocketscream/Low-Power).

Here is my final test code and my final good-to-compost code:                  
There are various time and temperature given for pathogens reduction and I choose to use the recommendation found in Niwagaba et al. (2009) [^1], coming from another source, that is 1 hour at ⩾ 62°C, 1 day at ⩾ 50°C, and 1 week at ⩾ 46°C.                 

```               
/*
   FILE   : test_compost_thermometre9.2

   AUTHOR : Nathalie Wéron

   DATE   : 2022-05-25

   LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).

   BASED ON :
    Blink
    modified 8 May 2014
    by Scott Fitzgerald
    modified 2 Sep 2016
    by Arturo Guadalupi
    modified 8 Sep 2016
    by Colby Newman
    This example code is in the public domain.
    https://www.arduino.cc/en/Tutorial/BuiltInExamples/Blink
   AND
    https://www.makerguides.com/ds18b20-arduino-tutorial/ for the thermometer code
    COPYRIGHT © 2021 MAKERGUIDES.COM
   AND
     for the 4-Digit 7-Segment Display
     https://www.makerguides.com/tm1637-arduino-tutorial/
   AND
     sleep mode while working
     https://circuitdigest.com/microcontroller-projects/arduino-sleep-modes-and-how-to-use-them-to-reduce-power-consumption
*/


#include <avr/sleep.h> // the AVR library contains the methods that controls the sleep modes
#include <LowPower.h>

#define LEDg1          3 // green LED 1 to say that the thermophilic treatment is done with Tobj1
#define LEDg2          4 // green LED 2 to say that the thermophilic treatment is done with Tobj2
#define LEDg3          5 // green LED 3 to say that the thermophilic treatment is done with Tobj3
#define LEDr           7 // red LED for Tmax
int Tobj1 = 20;  // 46°C is needed for 1 week time so 7*24*3600 = 604 800 seconds so t1 = 60 480
int t1 = 360; // time for Tobj1
int Tobj2 = 25;  // 50°C is needed for 1 days so 24*3600 = 86 400 seconds so t2 = 8 640
int t2 = 3; // time for Tobj2
int Tobj3 = 27;  // 62°C is needed for 1 hour time so 3600 seconds so t3 = 360
int t3 = 2; // time for Tobj3
int Tmax = 30;  // the compost should not have a temperature above 65°C
int time1 = -1; // start the count for Tobj1
int time2 = -1; // start the count for Tobj2
int time3 = -1; // start the count for Tobj3

#include <OneWire.h> // include both libraries
#include <DallasTemperature.h>
#define ONE_WIRE_BUS 8 // define the thermometre pin
OneWire oneWire(ONE_WIRE_BUS); // Create a new instance of the oneWire class to communicate with any OneWire device
DallasTemperature sensors(&oneWire); // Pass the oneWire reference to DallasTemperature library

#include <TM1637Display.h> // include the library
#define DIO 9
#define CLK 10
TM1637Display display = TM1637Display(CLK, DIO); // Create display object of type TM1637Display


void setup() {
  Serial.begin(9600); // initialize serial communication at 9600 bits per second

  pinMode(LEDg1, OUTPUT); // set the LEDs as output
  pinMode(LEDg2, OUTPUT);
  pinMode(LEDg3, OUTPUT);
  pinMode(LEDr, OUTPUT);

  sensors.begin(); // start up the library
}

void loop() {
  int t0 = millis();  // CAN BE REMOVED FOR FINAL
  sensors.requestTemperatures(); // Send the command for all devices on the bus to perform a temperature conversion
  float tempC = sensors.getTempCByIndex(0); // Fetch the temperature in degrees Celsius for device index, the index 0 refers to the first device

  // print the temperature in the Serial Monitor:                           CAN BE REMOVED FOR FINAL
  Serial.print("Temperature: ");
  Serial.print(tempC);   // print the temperature in Celsius
  Serial.println("°C");  // println to say it is the end of the line

  display.setBrightness(1); // Set the brightness: not a huge difference between 1 and 10
  display.showNumberDecEx(tempC); // display the temperature

  if (tempC >= Tobj1) {
    time1 = time1 + 1; // count 1 turn
  }
  else {
    time1 = 0; // reset time1
  }

  if (tempC >= Tobj2) {
    time2 = time2 + 1; // count 1 turn
  }
  else {
    time2 = 0; // reset time2
  }

  if (tempC >= Tobj3) {
    time3 = time3 + 1; // count 1 turn
  }
  else {
    time3 = 0; // reset time3
  }

  if ((time1 >= t1) || (time2 >= t2) || (time3 >= t3)) { // turn on the green light to say that the compost has done a thermophilic composting process
    if (time1 >= t1) { // to say that 46°C has been reached for 1 week
      digitalWrite(LEDg1, HIGH);   // turn the LEDg1 on (HIGH is the voltage level)
    }
    if (time2 >= t2) { // to say that 50°C has been reached for 1 day
      digitalWrite(LEDg2, HIGH);   // turn the LEDg2 on (HIGH is the voltage level)
    }
    if (time3 >= t3) { // to say that 60°C has been reached for 1 hour
      digitalWrite(LEDg3, HIGH);   // turn the LEDg3 on (HIGH is the voltage level)
    }
  }

  if (tempC >= Tmax) { //the compost has been to hot to be safe
    digitalWrite(LEDr, HIGH);   // turn the red LED on (HIGH is the voltage level)
  }

  Serial.println(time1);  // CAN BE REMOVED FOR FINAL
  delay (0); // no delay is needed, this code seems to make 1 turn in 10 seconds
  int t1 = millis (); // CAN BE REMOVED FOR FINAL
  Serial.println(t1 - t0); // CAN BE REMOVED FOR FINAL

  Serial.println("Going for a Nap");
  delay(25); // to give time to print the above, with 25 ms this code seems to make 1 turn in 10 seconds
  digitalWrite(LED_BUILTIN, LOW);
  LowPower.idle(SLEEP_8S, ADC_OFF, TIMER2_OFF, TIMER1_OFF, TIMER0_OFF,
                SPI_OFF, USART0_OFF, TWI_OFF);
  Serial.println("Just Woke up");
  int t2 = millis (); // CAN BE REMOVED FOR FINAL
  Serial.println(t2 - t0); // CAN BE REMOVED FOR FINAL
}               
```

```              

/*
   FILE   : compost_thermometre

   AUTHOR : Nathalie Wéron

   DATE   : 2022-05-27

   LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).

   BASED ON :
    Blink
    modified 8 May 2014
    by Scott Fitzgerald
    modified 2 Sep 2016
    by Arturo Guadalupi
    modified 8 Sep 2016
    by Colby Newman
    This example code is in the public domain.
    https://www.arduino.cc/en/Tutorial/BuiltInExamples/Blink
   AND
    https://www.makerguides.com/ds18b20-arduino-tutorial/ for the thermometer code
    COPYRIGHT © 2021 MAKERGUIDES.COM
   AND
     for the 4-Digit 7-Segment Display
     https://www.makerguides.com/tm1637-arduino-tutorial/
   AND
     for the sleep mode while working
     https://circuitdigest.com/microcontroller-projects/arduino-sleep-modes-and-how-to-use-them-to-reduce-power-consumption
*/

#include <LowPower.h>

#define LEDg1          3 // green LED 1 to say that the thermophilic treatment is done with Tobj1
#define LEDg2          4 // green LED 2 to say that the thermophilic treatment is done with Tobj2
#define LEDg3          5 // green LED 3 to say that the thermophilic treatment is done with Tobj3
#define LEDr           7 // red LED for Tmax
int Tobj1 = 46;  // 46°C is needed for 1 week time so 7*24*3600 = 604 800 seconds so t1 = 60 480
long t01 = 60480; // time for Tobj1: seconds / 10, 32 767 is the max value for int for arduino Uno -> long can go to 2 147 483 647
int Tobj2 = 50;  // 50°C is needed for 1 days so 24*3600 = 86 400 seconds so t2 = 8 640
int t02 = 8640; // time for Tobj2
int Tobj3 = 62;  // 62°C is needed for 1 hour time so 3600 seconds so t3 = 360
int t03 = 360; // time for Tobj3
int Tmax = 65;  // the compost should not have a temperature above 65°C
int time1 = -1; // start the count for Tobj1
int time2 = -1; // start the count for Tobj2
int time3 = -1; // start the count for Tobj3

#include <OneWire.h> // include both libraries
#include <DallasTemperature.h>
#define ONE_WIRE_BUS 8 // define the thermometre pin
OneWire oneWire(ONE_WIRE_BUS); // Create a new instance of the oneWire class to communicate with any OneWire device
DallasTemperature sensors(&oneWire); // Pass the oneWire reference to DallasTemperature library

#include <TM1637Display.h> // include the library
#define DIO 9
#define CLK 10
TM1637Display display = TM1637Display(CLK, DIO); // Create display object of type TM1637Display


void setup() {
  Serial.begin(9600); // initialize serial communication at 9600 bits per second

  pinMode(LEDg1, OUTPUT); // set the LEDs as output
  pinMode(LEDg2, OUTPUT);
  pinMode(LEDg3, OUTPUT);
  pinMode(LEDr, OUTPUT);

  sensors.begin(); // start up the library
}

void loop() {
  int t0 = millis(); // start a counter for the time between 2 points
  sensors.requestTemperatures(); // Send the command for all devices on the bus to perform a temperature conversion
  float tempC = sensors.getTempCByIndex(0); // Fetch the temperature in degrees Celsius for device index, the index 0 refers to the first device

  // print the temperature in the Serial Monitor:
  Serial.print("Temperature: ");
  Serial.print(tempC);   // print the temperature in Celsius
  Serial.println("°C");  // println to say it is the end of the line

  display.setBrightness(1); // Set the brightness: not a huge difference between 1 and 10
  display.showNumberDecEx(tempC); // display the temperature

  if (tempC >= Tobj1) {
    time1 = time1 + 1; // count 1 turn
  }
  else {
    time1 = -1; // reset time1
  }

  if (tempC >= Tobj2) {
    time2 = time2 + 1; // count 1 turn
  }
  else {
    time2 = -1; // reset time2
  }

  if (tempC >= Tobj3) {
    time3 = time3 + 1; // count 1 turn
  }
  else {
    time3 = -1; // reset time3
  }

  if (time1 >= t01) { // to say that 46°C has been reached for 1 week
    digitalWrite(LEDg1, HIGH);   // turn the LEDg1 on (HIGH is the voltage level)
  }
  if (time2 >= t02) { // to say that 50°C has been reached for 1 day
    digitalWrite(LEDg2, HIGH);   // turn the LEDg2 on (HIGH is the voltage level)
  }
  if (time3 >= t03) { // to say that 60°C has been reached for 1 hour
    digitalWrite(LEDg3, HIGH);   // turn the LEDg3 on (HIGH is the voltage level)
  }

  if (tempC >= Tmax) { //the compost has been to hot to be safe
    digitalWrite(LEDr, HIGH);   // turn the red LED on (HIGH is the voltage level)
  }

  Serial.println(time1);

  delay (0); // no delay is needed, this code seems to make 1 turn in 10 seconds

  int t1 = millis (); //
  Serial.println(t1 - t0); // measures the time passed between t0 and t1

  Serial.println("Nap");
  delay(25); // to give time to print the above, with 25 ms this code seems to make 1 turn in 10 seconds
  LowPower.idle(SLEEP_8S, ADC_OFF, TIMER2_OFF, TIMER1_OFF, TIMER0_OFF,
                SPI_OFF, USART0_OFF, TWI_OFF);

  Serial.println("Woke up");

  int t2 = millis ();
  Serial.println(t2 - t0); // measures the time passed between t0 and t2
}           
```

### 1.4.Creation process
At first I used a LM35 Temperature Sensor like in my arduino FabZero module but I needed a long waterproof Temperature Sensor so I changed for a DS18B20 and my codes changed accordingly.
I also tried different thing for the ON/OFF button that was later changed for a switch on the battery.

During the code writing I had some problems:

* The LM35 Temperature Sensor was working but gave temperatures above 100°C . I changed the temperatures in the code to test its principle but I needed to understand the sensor problem.            

 **Explanation**: the sensor was connected to the analogic input 1 instead of 0 used in the code so it was capturing electronic perturbations.

* For a moment, I forgot to update the code on the arduino board but I was changing it on my computer as I could not see any improvement. Then I remembered to update the arduino and the problem was solved.

* When a LED is connected to the digital pin 1, it is slightly blinking event if the code does not include turning on a LED.

* When any LED is HIGH, the thermometre does not work (-127.00°C).               
 **Explanation**: I did not wire the ground.         

I worked in a incremental manner: every codes are [available on my gitlab](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/tree/main/docs/Final-project/Arduino), only the last 2 are on this page.

First, I thought about using a green LED to say when the compost is ready, yellow LEDs to say when the objective temperatures are reached and a red LED to say when to compost heated too much.

1. test_compost_thermometre: the thermometre

2. test_compost_thermometre2: the thermometre, 1 yellow, 1 green and 1 red LEDs

3. test_compost_thermometre3: the thermometre, 3 yellow, 1 green and 1 red LEDs

4. test_compost_thermometre4: the thermometre, 3 yellow, 1 green and 1 red LEDs, button

But then I add a digit display because knowing the temperature is good to manage it. So I changed the yellow LEDs to say which temperature has been reached for a sufficient time. Plus I changed the button code because the button that I bought was not working with it.

5. test_compost_thermometre5: the thermometre, 3 yellow LEDs to say that their objective temperatures has been reached, 1 green and 1 red LEDs, button, digit display

6. test_compost_thermometre6: the thermometre, 3 yellow LEDs to say which temperature has been reached for a sufficient amount of time, 1 green and 1 red LEDs, button with interruption, digit display

7. test_compost_thermometre6_newbutton: the thermometre, 3 yellow LEDs to say which temperature has been reached for a sufficient amount of time, 1 green and 1 red LEDs, button without interruption (needs a bit more time on the button to stop the code), digit display

Finally, I though that having a green LED is not useful anymore so only 4 LEDs (1 red and 3 yellow) are used. I would like to change the colour from yellow to green though.

8. test_compost_thermometre7 and test_compost_thermometre7_newbutton

Then I added a sleep mode using the same interruption as the button and a sleep mode in the running code to save energy.

9. test_compost_thermometre8: sleep mode when the thermometre is not working

10. test_compost_thermometre9: 8 seconds of sleep mode while the thermometre is working and sleep mode when the thermometre is not working

**Update**: trying to solve the new button problem with the old button code.

* a debounce circuit does not work.

![debounce circuit](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/debounce-sch.jpg)

* old_action does not work (test_compost_thermometre6.2).

* Replacing the button with a switch -> easier code.

11. test_compost_thermometre9.2: adding the switch, removing the button, sleep mode of 8 seconds when the thermometre is working

12. compost_thermometre: the final code. I needed to change one integer to a long because its value was too high, I removed one library that was no more necessary, I changed t1, t2 and t3 to t01, t02 and t03 because I used t1 and t2 for measuring time passing during the code, I kept everything that I though about removing for the final code.

## 2.Transforming a simple bucket into a composting bucket

The idea was to transform a toilet bucket into a composting bucket for the thermophilic phase of composting then to do vermicomposting in the same bucket. My idea was to fill the bucket in the toilet, wait for the thermophilic phase to pass by monitoring it with the compost thermometre, then add earthworms to the first bucket. The following buckets would be placed on top of the first bucket and earthworms would migrate to these new buckets to eat.            

I based my composting bucket on [the Low-tech Lab vermicomposter French sheet](https://wiki.lowtechlab.org/wiki/Lombricomposteur_simple).                 
 Both the vermicomposter and [the bokashi bucket](https://wiki.lowtechlab.org/wiki/Compost_Bokashi_de_cuisine/en) of the Low-tech Lab have a bottom part to receive the liquid and a tap. Hence both were added to my bucket design.             
As a tap is used, I thought that it would be better to add a slope to the bottom part to help the liquid go in the tap even if the tap is not placed at the lowest because of the space needed to fix it. So I created a slope to put in the bottom tank.                  
The bucket itself needs holes for the liquid to flow to the bottom tank. The first bucket needs holes of 2 mm for the liquid to pass but not the earthworms. The following buckets first need 2 mm holes then 8 mm holes during the vermicomposting phase to allow earthworms to pass between the buckets. Therefore I added a holes circle that is placed on the exterior of the bucket to ease the change of holes diametre. It has holes of 2 and 8 mm while the bucket only has 8 mm holes. The goal of the holes circle is to decrease the 8 mm diametre holes to 2 mm.           
The tank and the bucket need to be linked so I created an adaptor for them with a support for the bucket to not fall in the larger tank.

### 2.1.Materials

* 2 reused plastic (food) buckets of 5 litres: free

* 1 purchased metal tap 1/2M x3/8F, 2 joints 25X18mm and 1 nut 3/4M X 1/2F: 31€97              
![metal tap](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/metal_tap.jpg)
  or             
  1 reused watering tap without joint: free           
![plastic tap](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/plastic_tap.jpg)

* 1 box of screws with nuts M3X16mm: 4€99 for too much

TOTAL: 36€96 for me

The university food sellers did not give me any bucket because they do not have them or keep all of them to use them as cleaning buckets ... I think it is a little suspicious ... Anyway I found buckets at a sandwich place and a zero-waste food shop near the FabLab.             
I bought a bucket for 4€19 before knowing that I could find buckets. It is not the best because it has another form and does not have a lid so I will not use it.

### 2.2.Instructions
This fabrication needs 3 3D printings and 2 laser cuttings. If you do not have access to theses technologies you can simply follow the Low-tech Lab sheet and cut the holes circle in a spare plastic lid.

1. On the first bucket, cut the hole for the tap taking into account the space needed to fix it.              
  I cut the tap hole at 6 mm from the edge because my tap fixer is +- 5 mm width. I used a simple cutter.

  ![hole cutting](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/hole_cutting.jpg)

2. Put the tap in place to verify the watertightness then take it back

  ![tap in place](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/tap_place.jpg)

3. Take the measure to calculate the radius of the inner bottom of the first bucket.              
  I did it and the result was not bad but a little bit too little.              
  With the formula r = l/2*pi: l = 61cm so r = 97.1 mm and I changed for 97.5 mm for a better fit.                        

4. Use this radius in the slope file, choose the slope that you want to add and 3D print it.                
  I chose a 1 cm slope. I added 0.4 mm to the calculated radius for a better fit.               
  With an infill of 15% in honeycomb, the 3D printing takes 7h13. You do not need any brim nor skirt.

  Here is the slope.scad file: it has a radius test that you can print to confirm the value before printing the entire slope, you just need to remove some / and *. Of course you need to change the radius according to your bucket.

  ![real slope picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/real_slope.jpg)

  ![bucket_slope picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bucket_slope.jpg)

```            
  /*
FILE   : bucket_slope.scad

AUTHOR : Nathalie Wéron

DATE   : 2022-05-07
MODIFIED : 2022-05-20

LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).

//*/

  $fn = 200;
  radius = 97.5; // (97.1) is a bit little but enough. calculate the radius interior (!) of the bucket (the slope needs to enter the bucket to the bottom) with r = l/2*pi, l = 61cm -> r = 97.1
  slope = 10; // height of the slope

  /*
  // radius test:
  difference (){
      cylinder (1, r = radius, center = true);
      cylinder (1, r = radius-5, center = true);
  }
  //*/


  //Code:
  difference (){
      cylinder (slope, r = radius, center = true); // base
      rotate ([atan(slope/(2*radius)),0,0]) // cut for the slope
          translate ([0,0,slope/2])
              cylinder (slope, r1 = radius +1, r2 = radius, center = true);
}
//*/          
```

5. Put the slope then the tap in place.         
  Verify that it is watertight.

  ![slope in bucket](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/slope_bucket.jpg)

6. Cut this bucket at more than 1 cm over the tap.           
  My tap is 3 cm wide with its fixating space so I cut at 4.5 cm from the edge.

  ![bucket line cut](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bucket_line_cut.jpg)

7. Take the measures of the perimetre to calculate the top diametre of this bucket, and the bottom diametre of the second bucket.          
  I found that the claculated radius is a bit too big and that reducing it by 0.6 mm is better so:
  r = l/2*pi -> real r = r - 0.6 mm

8. Use those measures in the adaptor file and print the adaptor.           
  Here is the adaptor4.scad code: you do not need the code test for the design but I used it to see if I needed support or not.             
  You need to 3D print the adaptor with the little radius facing the tray and with a brim (3 mm is good). You can print it without support. You can choose the other parametres. I used 25% infill in honeycomb and no skirt.          

  ![adaptor strip with and without brim](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/adaptor_strip.jpg)
  ![bucket_adaptor4 picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/adaptor4.jpg)

```            
  /*
  FILE   : bucket_adaptor4.scad

  AUTHOR : Nathalie Wéron

  DATE   : 2022-05-16

  LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).

  //*/

  $fn = 200;
  rtop = 97.6; // (97.6) is perfect. calculate the radius exterior (!) of the bottom of the bucket with r = l/2*pi, l = 61.7 cm -> r = 98.2 mm but trying with (97.9) is nearly perfect, a little bit too big, 97.5 should be good, real r = 97.6.
  // the bottom of the other bucket is l = 64.4 cm -> r = 102.5 mm but trying with (100.9+1) is perfect -> real r = r - 0.6.
  rbottom = 103.5; // (103.5) is perfect but a bit tight so push a bit. calculate the radius exterior (!) of the bucket at the correct height (4.5cm) with r = l/2*pi, l = 65.4 cm -> r = 104.1 mm -> real r = 103.5 mm
  rmax = rbottom; // the body needs to be bigger than both buckets so the bigger radius is used
  rmin = rtop; // the inner quadrilater needs to be adapted to the little radius
  thickness = 1; // thickess of the external part of the adaptor
  height = 22; // total height of the adaptor
  half_height = 10; // height of the adaptor on both bucket -> 2 mm of thickness between the 2 buckets
  n_side = 9; // choose the number of side for the inner hole
  angle = 360/n_side; // angle interior
  length = rmin * 2*cos ((180-angle)/2); // length of each little support
  translation = rmin * sin((180-angle)/2); // translation of the cubes to cut all the interior
  turn = n_side-1; // 0 to n_side-1 rotation for the cubes

  /*
  //to see if the holes file would touch the adaptor
  diff = 7;

  translate ([0,0,half_height])
      cylinder (thickness, r = 97.9 - diff); // test for the holes disc

  /*

  //code test for the design:
  difference () {
      cylinder(1, r = rmax + thickness); // body
      cylinder(0.4, r = rbottom); // bottom hole
      translate ([0,0,1-0.4]) // top hole
          cylinder(0.4, r = rtop);

      for (i = [0:turn]){ // octogone hole
          rotate ([0,0,i*angle]) {
              translate ([-length/2,-translation,0.4])
                  cube ([length,rmin,height-2*half_height]);
          }
      }
  }

  //*/

  // Code:
  difference () {
      hull (){
      cylinder(height-half_height, r = rbottom + thickness); // body bottom
      translate ([0,0,height-half_height])
          cylinder(half_height, r = rtop + thickness); // body top
      }
      cylinder(half_height, r = rbottom); // bottom hole
      translate ([0,0,height-half_height]) // top hole
          cylinder(half_height, r = rtop);

      for (i = [0:turn]){ // octogone hole
          rotate ([0,0,i*angle]) {
              translate ([-length/2,-translation,half_height])
                  cube ([length,rmin,height-2*half_height]);
          }
      }
  }         
```

9. Cut the holes circle in a 1 mm thick polypropylene sheet.               
  I made the holes circle in openscad then I exported it in svg to be able to laser cut it. The holes circle cannot touch the adaptor. In the adaptor code (adaptor4.scad) you can see if the holes file would touch the adaptor before laser cutting the holes circle.              

  Here you have the holes2plan.scad code:

  ![holes2plan](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/holes2plan.jpg)

```             
  /*
  FILE   : holes2plan.scad

 AUTHOR : Nathalie Wéron

 DATE   : 2022-05-11
MODIFIED : 2022-05-20

 LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).
//*/

 $fn = 200;
rtop = 97.9; // radius of the bucket
diff = 7; // distance between the bucket exterior and the holes disc exterior
rholes = 1; // 2mm of diametre
rcenter = 1.5; // for screw with a 3 mm diametre
distance = 40; // distance between the holes centres
rholes8 = 4; // 8 mm of diametre
n = 6; // number of holes lines
angle = 360/n; // angle for the rotations

 // Code:
difference (){
    circle (r = rtop - diff); // disc
    circle (r = rcenter); // center hole for the attach of the disc to the bucket
    for (i = [0:n]){ // 2 mm holes
        rotate ([0,0,i*angle*2]) { // space
            translate ([0.5*distance,0,0])
                circle (r = rholes);
        }
        rotate ([0,0,i*angle]) { // space
            translate ([1.5*distance,0,0])
                circle (r = rholes);
            rotate ([0,0,angle/2]){ // delay
                translate ([distance,0,0])
                    circle (r = rholes);
                translate ([2*distance,0,0])
                circle (r = rholes);
            }
        }
    }
    for (i = [1:n]){ // 8 mm holes
        rotate ([0,0,i*angle*2]) { // space
            rotate ([0,0,angle/2]){ // delay
                translate ([0.5*distance,0,0])
                    circle (r = rholes8);
                }
            }
        rotate ([0,0,i*angle]) { // space
            translate ([distance,0,0])
                circle(r = rholes8);
            translate ([2*distance,0,0])
                circle (r = rholes8);
            rotate ([0,0,angle/2]){ // delay
                translate ([1.5*distance,0,0])
                    circle(r = rholes8);
            }
        }
    }
}           
```

  In Inkscape I took the fill off and I put 0.1 mm of stroke thickness. The file I used is holes2planV2.svg and it is [available on my gitlab](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/Laser/holes2planV2.svg).

  On the Lasersaur: 2 300 mm/min and 100% was not enough to cut so I changed to 1600 mm / min and 100% but it nearly burn the polypropylene ... at least it is working. I would nonetheless recommend to try with 2 000 mm / min instead.           
  The 2 mm diametre holes became 2.5 mm and the 8 mm became 8.5 mm. It is possible to decrease accordingly the radius in the holes2plan.scad file.

  On the Epilog: change the stroke to 0.01 mm and use 20% speed and 70% power. The 2 mm holes were not cleanly cut because the polypropylene is melting on itself but I accept the result.

  ![holes circle picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/holes_circle.jpg)

10. Cut only the 8 mm holes and the centre hole on the second bucket bottom.                 
  I took the holes2planV2.svg file and I removed the big circle and the 2 mm holes. The new file is named holes2planV2bucket.svg and it is [available on my gitlab](https://fablab-ulb.gitlab.io/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/Final-project/Laser/holes2planV2bucket.svg).

  With the Epilog (laser cutter) it is possible to cut the bottom of the top bucket if the bucket is less than 31 cm high. The tray needs to be lower. It is possible to do the autofocus then and to use the red pointer to adjust the cutting on the bucket. By running a 0% power cutting you can see the red pointer moving and adjust the drawing position on the computer.      

  ![epilog strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/Epilog_strip1.jpg)                 
  ![Epilog end](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/Epilog_redpoint.jpg)  

  I used the same parameter as for the 1 mm thick polypropylene: 20% speed and 70% power. It is always better to put the frequency to the maximum, 100%.

11. Assemble the second bucket and the holes circle with a screw and a nut.               
  Fix it well.

  ![bucket with holes circle](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bucket_holescircle.jpg)

12. Put the second bucket over the first bucket using the adaptor

  ![adaptor on buckets picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/adaptor_bucket.jpg)                 
  (I did not put the tap or the slope but you get the idea.)

THE END ?

You can cut the top of the second bucket to replace it by the top of the first bucket. It would increase the composting bucket capacity.        

13. Take the measures to change the adaptor file.        

14. Print the second adaptor.           

15. Put the top of the first bucket over the bottom of the second bucket using the adaptor.        

  ![final bucket picture](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/final_bucket.jpg)

TADAAAM

### 2.3.Now what ?              
I realized that putting composting bucket in top of each other was not a good idea to sanitise them because of liquid transfer from new buckets to old ones.                   
My new idea is therefore to use the bucket only for the thermophilic composting phase then to empty it in a larger vermicompost bin that would be closed for the correct amount of time to treat its content. Thus the buckets would not need a holes circle because they would just need 2 mm holes for the liquid to flow in the tank below.

Moreover, here it is only a prototype made with 5 litres plastic bucket but my ideal bucket would be a 20 litres inox bucket. Inox is already used for toilet bucket as it is resistant to urine, easy to wash and durable.

![inox bucket](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/seau_inox.jpg)                      
Pircture from the [So toilette sèche website.]((https://www.seau-toilette-seche.com/seau-pour-toilettes-seches/seau-inox/))

The inox adaptor can be a 2 part object: one support to put between the bucket and the bottom tank and a piece that can look like a cake mold already existing with a line of silicon to adhere to the bucket.

![inox adaptor strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/adaptor_inox_strip.jpg)                 
(Here you have the test that I made for the adaptor but you get the idea.)

The bottom tank would need a tap to ease the liquid emptying. The tap would need to be the smallest possible. I do not know whether it is better for it to be in inox as well but why not.

The slope can be already included in the inox bottom tank (if possible). Or no slope ?

The lid of the inox bucket can be based on an inox food box: a line of silicon makes it watertight and the box has a mecanism for the lid to stay in place.

![inox lid strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/inox_lid_strip.jpg)

With all of those innovations, the bucket would stay in aerobic condition and could be tightly closed to avoid spillage.          

### 2.4.Creation process            

#### 2.4.1.A Complete stand ?         
At first I thought that I had to 3D print the whole base so I did several bottom_bucket.scad files. The printing time was really high because I tried to have a flat surface for the tap. The size of the tap was also a constrain to had it on the flat surface. Putting the tap on the bottom would give more space but the bucket would need a stand.

Here is the code of one bottom bucket squared: the bottom_bucket_squared_ideal.                 
It has a squared tank for a circle bucket, a slope and flat walls for the tap.          

![bottom_bucket_squared_ideal](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bottom_bucket_squared_ideal.jpg)

```
/*
FILE   : bottom_bucket_squared_ideal.scad

AUTHOR : Nathalie Wéron

DATE   : 2022-05-05
MODIFIED : 2022-05-25

LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).
//*/

$fn = 200;
bottom = 3; // thickness of the bottom
bottom_height = 50; // height of the bottom under the bucket
radius = 100; // radius of the bucket
little_height = 10; // height of the part entouring the bucket
neg_thickness = 2; // thickness of the sides
thickness = 1;
tap_hole = 20/2; // 20 mm the internal part of the tap that goes through the tap hole
tap_fixer = (30-20)/2; // 30 mm the external size of the tap screw thing
cyl_radius1 = radius/2; // radius of the rounded corner of the bottom piece
cyl_radius2 = radius/3.5; // coefficient to modify the bottom part: near 50 -> like a cube with rounded corner, near 0 -> like the top part has been rotated to 90 degrees
slope = 10; // slope in the bottom of the piece


// Code:
difference (){
    union (){
        hull () { //liquid location
            translate ([cyl_radius1,cyl_radius1,0])
            cylinder(bottom_height, r1 = cyl_radius1+thickness, r2 = cyl_radius2);
            translate ([cyl_radius1,-cyl_radius1,0])
            cylinder(bottom_height, r1 = cyl_radius1+thickness, r2 = cyl_radius2);
            translate ([-cyl_radius1,-cyl_radius1,0])
            cylinder(bottom_height, r1 = cyl_radius1+thickness, r2 = cyl_radius2);
            translate ([-cyl_radius1,cyl_radius1,0])
            cylinder(bottom_height, r1 = cyl_radius1+thickness, r2 = cyl_radius2);
            translate ([cyl_radius1,0,0])
            cylinder(bottom_height, r1 = cyl_radius2+thickness, r2 = cyl_radius1);
            translate ([0,cyl_radius1,0])
            cylinder(bottom_height, r1 = cyl_radius2+thickness, r2 = cyl_radius1);
            translate ([-cyl_radius1,0,0])
            cylinder(bottom_height, r1 = cyl_radius2+thickness, r2 = cyl_radius1);
            translate ([0,-cyl_radius1,0])
            cylinder(bottom_height, r1 = cyl_radius2+thickness, r2 = cyl_radius1);

        translate ([0,0,bottom_height]) // bucket size
            cylinder(little_height, r = radius+thickness);
        }

    }
    // HOLES
    translate ([0,0,bottom_height-(thickness + neg_thickness)]) // bucket size
            cylinder(little_height+(thickness + neg_thickness), r = radius);
    translate ([radius-neg_thickness,0,bottom+tap_hole+tap_fixer]) // tap hole
            rotate ([0,90,0])
                cylinder ((thickness + neg_thickness), r = tap_hole);
    hull () { // liquid location
            translate ([cyl_radius1,cyl_radius1,bottom])
            cylinder(bottom_height-(thickness + neg_thickness)*2, r1 = cyl_radius1-neg_thickness, r2 = cyl_radius2-neg_thickness);
            translate ([cyl_radius1,-cyl_radius1,bottom])
            cylinder(bottom_height-(thickness + neg_thickness)*2, r1 = cyl_radius1-neg_thickness, r2 = cyl_radius2-neg_thickness);
            translate ([-cyl_radius1,-cyl_radius1,bottom+slope])
            cylinder(bottom_height-(thickness + neg_thickness)*2-slope, r1 = cyl_radius1-neg_thickness-slope, r2 = cyl_radius2-neg_thickness);
            translate ([-cyl_radius1,cyl_radius1,bottom+slope])
            cylinder(bottom_height-(thickness + neg_thickness)*2-slope, r1 = cyl_radius1-neg_thickness-slope, r2 = cyl_radius2-neg_thickness);
            translate ([cyl_radius1,0,bottom])
            cylinder(bottom_height-(thickness + neg_thickness)*2, r1 = cyl_radius2-neg_thickness, r2 = cyl_radius1-neg_thickness);
            translate ([0,cyl_radius1,bottom+slope])
            cylinder(bottom_height-(thickness + neg_thickness)*2-slope, r1 = cyl_radius2-neg_thickness, r2 = cyl_radius1-neg_thickness);
            translate ([-cyl_radius1,0,bottom+slope])
            cylinder(bottom_height-(thickness + neg_thickness)*2-slope, r1 = cyl_radius2-neg_thickness, r2 = cyl_radius1- neg_thickness);
            translate ([0,-cyl_radius1,bottom+slope])
            cylinder(bottom_height-(thickness + neg_thickness)*2-slope, r1 = cyl_radius2-neg_thickness, r2 = cyl_radius1-neg_thickness);
        }
}
```

Then I realised that I would not need to 3D print the whole ideal bucket bottom if I printed an adaptor and a slope to change a simple bottom bucket into the one I designed in 3D.          

After the try with the circle tank, I saw that the tap is watertight in a curve. Then a complete circle stand would take 15 hours. With that amount of time, a bucket_size_test.scad would be great.                 

Here is the code of the bottom_bucket.scad : it is like the bottom_bucket_quared_ideal but in circle.         

![bottom_bucket](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bottom_bucket.jpg)

```
/*
FILE   : bottom_bucket.scad

AUTHOR : Nathalie Wéron

DATE   : 2022-05-04
MODIFIED : 2022-05-17
MODIFIED : 2022-05-20

LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).

//*/

$fn = 200;
bottom = 1; // thickness of the bottom
height = 45+bottom; // height of the piece
radius = 100; // radius of the bucket
support = 2; // thickness of the support
little_height = 10; // height covering the bucket
thickness = 1; // thickness of the wall
tap_hole = 21/2; // diametre / 2  of the tap hole
tap_fixer = 5; // space to fix the tap
n_side = 9; // choose the number of side for the inner hole
angle = 360/n_side; // angle interior
length = radius * 2*cos ((180-angle)/2); // length of each little support
translation = radius * sin((180-angle)/2); // translation of the cubes to cut all the interior
turn = n_side-1; // 0 to n_side-1 rotation for the cubes
slope = 10; // height of the slope

// Code:
difference (){
    cylinder(height, r = radius+thickness); // body
    translate ([0,0,height-little_height]) // bucket size
            cylinder(little_height, r = radius);
    for (i = [0:turn]){ // octogone hole
        rotate ([0,0,i*angle]) {
            translate ([-length/2,-translation,height - little_height-support])
                cube ([length,radius,support]);
        }
    }
    translate ([0,0,bottom + slope]) // liquid location
            cylinder(height-little_height-support-slope, r = radius);
    rotate ([0,atan(slope/(2*radius)),0]) // slope
        translate ([0,0,bottom + slope/2])
            cylinder (slope, r1 = radius, r2 = radius - 1);
    translate ([radius-thickness,0,bottom+tap_hole+tap_fixer]) // hole for the tap
            rotate ([0,90,0])
                cylinder (thickness*2, r = tap_hole);
}
```

And I put you here the bucket_size_test: do not forget to put a brim.

![bucket_size_test](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bucket_size_test.jpg)

```
/*
FILE   : bucket_size_test.scad

AUTHOR : Nathalie Wéron

DATE   : 2022-05-06

LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).
//*/

$fn = 200;
radius = 100; // radius of the bucket: top or bottom
little_height = 10; // height of the part entouring the bucket
thickness = 1;

//Code:
difference (){
        cylinder(little_height, r = radius+thickness); // bucket size
        cylinder(little_height, r = radius); // bucket size hole
}
```

#### 2.4.2.The adaptor

The bucket_adaptor.scad was the first idea of the adaptor but it uses more plastic for nothing. The principle is simple and stay the same in the other version: you have two circle on top of each other with a 2 mm thick wall in between. The wall has a hole in it in the shape of a polygon. You can choose the number of sides but I choose 9. Also the bigger circle has a thickness of 1 mm.           

![adaptor original](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/adaptor_original.jpg)       

I made 2 buckets so I have bucket_adaptor2 and 3 for the first one and bucket_adaptor4 and 5 for the second. It is the same code but with different values for the buckets radius. I added a part in the code to test the values used for the holes circle so as it does not touch the adaptor.                         

bucket_adaptor2.scad:          
It is the first that I printed and I learned that adaptors need a brim to stick to the tray.

bucket_adpator3 and 4 were goods.

bucket_adaptor5.scad:               
The adaptor5 is too big for the printer so I thought about cutting a part of it for it to hold on the tray.               
**Result**: it was a bad idea. The resulting adaptor is not working because it is not rigid. I should have know. So your buckets really have to be smaller than the 3D printing tray.

![adaptor 5 file](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/adaptor5.jpg)

I did a bucket_size_test.scad to test the radius before printing the adaptors but it takes 1 hour per side to print and I never used it. I thought that if the measure is right, it would be a waste, and if the measure is not right then it would be a waste and I would change for a better one that would be a waste if I test it.               

#### 2.4.3.The slope              

bucket_slope.scad:                
It is just a cylinder cut by another cylinder that is rotated in one way. I used trigonometry so you can just change the slope parametre (in mm) and you have a nice slope.          

With an infill of 25%, the 3D printing of the test takes 30 minutes, a 3 mm slope takes 3:30 hours and a 1 cm slope takes nearly 9 hours.                
With an infill of 15%, the 3D printing takes 7h13 for 1 cm slope so I did that.                


#### 2.4.4.The holes disc
Like I said, my design is based on the Low-tech Lab vermicompost bucket. They use 2 mm holes for the liquid and 8 mm holes for the worms so I made a holes disc with those values.
I tried various design for the holes number and location: it was a bit difficult to find a good locations for the holes.

* holes.scad has a symetry of 8:             
  It is not bad but the centre part is hard to design.

  ![image holes](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/image_holes.jpg)

* holes2.scad has a symetry of 6:            
  I thought that it would be better for the centre so I chose this design.

![image holes2](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/image_holes2.jpg)

First I wanted to 3D print this. It would take 2:18 hours for the holes2. The printer I used did not finish before turning down (maybe it had a problem). Axel (one Fab manager) told me "why not using the laser cutter instead" and it was a good idea.

I changed the code to have a 2D object (holes2plan.scad) and I exported it in SVG (holes2plan.svg). In Inkscape I took the fill off and I put 0.1 mm of stroke thickness. In the meantime I changed the radius of the top bucket so I needed a second version for the holes disc (radius = 97.9 in holes2plan.scad and holes2planV2.svg).
I used the Lasersaur but it often has problems: this time the svg file was not centered so I increased the page size. In _File_ > _Document Properties ..._ > _Page_ I put 400 mm for the width and height as custom size and I moved the drawing in the bottom right corner.

For the holes2planV2bucket.svg I used the holes2planV2.svg but I deleted the 2 mm holes and the big circle and changed the stroke to 0.01 mm.

Here is the holes2.scad code: it is the same as the plan version but in 3D. In the meantime I changed the radius (rtop) value so they do not have the same values.

```
/*
FILE   : holes2.scad

AUTHOR : Nathalie Wéron

DATE   : 2022-05-06
MODIFIED:  2022-05-10
MODIFIED:  2022-05-11

LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).
//*/

$fn = 200;
rtop = 98.3; // radius of the bucket
diff = 7; // distance between the bucket exterior and the holes disc exterior
rholes = 1; // 2mm of diametre
thickness = 1;
rcenter = 1.5; // for screw with a 3 mm diametre
distance = 40; // distance between the holes centres
rholes8 = 4; // 8 mm of diametre
n = 6; // number of holes lines
angle = 360/n; // angle for the rotations

// Code:
difference (){
    cylinder (thickness, r = rtop - diff); // disc
    cylinder (thickness, r = rcenter); // center hole for the attach of the disc to the bucket
    for (i = [0:n]){ // 2 mm holes
        rotate ([0,0,i*angle*2]) { // space
            translate ([0.5*distance,0,0])
                cylinder (thickness, r = rholes);
        }
        rotate ([0,0,i*angle]) { // space
            translate ([1.5*distance,0,0])
                cylinder (thickness, r = rholes);
            rotate ([0,0,angle/2]){ // delay
                translate ([distance,0,0])
                    cylinder (thickness, r = rholes);
                translate ([2*distance,0,0])
                cylinder (thickness, r = rholes);
            }
        }
    }
    for (i = [1:n]){ // 8 mm holes
        rotate ([0,0,i*angle*2]) { // space
            rotate ([0,0,angle/2]){ // delay
                translate ([0.5*distance,0,0])
                    cylinder (thickness, r = rholes8);
                }
            }
        rotate ([0,0,i*angle]) { // space
            translate ([distance,0,0])
                cylinder (thickness, r = rholes8);
            translate ([2*distance,0,0])
                cylinder (thickness, r = rholes8);
            rotate ([0,0,angle/2]){ // delay
                translate ([1.5*distance,0,0])
                    cylinder (thickness, r = rholes8);
            }
        }
    }
}
```

And here is holes.scad:

```
/*
FILE   : holes.scad

AUTHOR : Nathalie Wéron

DATE   : 2022-05-06
MODIFIED:  2022-05-10
MODIFIED:  2022-05-11

LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).
//*/

$fn = 200;
radiustop = 194/2; // radius of the bucket
diff = 7; // distance between the bucket exterior and the holes disc exterior
rholes = 1; // 2mm of diametre
thickness = 1;
rcenter = 1.5; // for screw with a 3 mm diametre
distance = 40; // distance between the holes centres
rholes8 = 4; // 8 mm of diametre
n = 8; // number of holes lines
angle = 360/n; // angle for the rotations

// Code:
difference (){
    cylinder (thickness, r = radiustop - diff); // disc
    cylinder (thickness, r = rcenter); // center hole for the attach of the disc to the bucket
    for (i = [0:n]){ // 2 mm holes
        rotate ([0,0,i*angle*n/2]) { // space
            translate ([0.5*distance,0,0])
                cylinder (thickness, r = rholes);
        }
        rotate ([0,0,i*angle]) { // space
            translate ([1.5*distance,0,0])
                cylinder (thickness, r = rholes);
            rotate ([0,0,angle/2]){ // delay
                translate ([distance,0,0])
                    cylinder (thickness, r = rholes);
                translate ([2*distance,0,0])
                    cylinder (thickness, r = rholes);
            }
        }
    }
    for (i = [1:n]){ // 8 mm holes
        rotate ([0,0,i*angle*n/2]) { // space
            rotate ([0,0,3*angle/2]){ // delay
                translate ([0.5*distance,0,0])
                    cylinder (thickness, r = rholes8);
                }
            }
        rotate ([0,0,angle/2]){ // delay
            rotate ([0,0,i*angle]) { // space
                translate ([1.5*distance,0,0])
                    cylinder (thickness, r = rholes8);
                rotate ([0,0,angle/2]){ // delay
                    translate ([distance,0,0])
                        cylinder (thickness, r = rholes8);
                    translate ([2*distance,0,0])
                        cylinder (thickness, r = rholes8);
                }
            }
        }
    }
}          
```

#### 2.4.5.The taps            
After buying the metal tap I tried to reused some tap that I could find.          

The apple juice tap was not useful because it did not have a screw thing.         
![bad tap](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bad_tap.jpg)

I gathered 4 different taps and 2 were good enough for me and are showed above. The other 2 were straight, too big and too heavy or made in a not really resistant plastic.          

![all taps](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/taps.jpg)


#### 2.4.6.The little tap
After starting to use my second bucket that did not have a tap I found it difficult to empty to bottom tank back in the bucket.

In the taps that I had, one was from a system to water plants from a bottle. It is a common object sold by different sellers and you can find it on [Amazon](https://www.amazon.fr/LABOTA-Irrigation-Arroseurs-automatiques-Int%C3%A9rieur/dp/B07T6FJGL6/ref=sr_1_15_sspa?c=ts&keywords=Kits+d%27arrosage+automatiques+goutte+%C3%A0+goutte&qid=1653691869&s=lawn-garden&sr=1-15-spons&ts_id=4338694031&psc=1&spLa=ZW5jcnlwdGVkUXVhbGlmaWVyPUEzMDJRM1hGWlBWQlgxJmVuY3J5cHRlZElkPUEwNjUxOTg3MkxJMUFXMjQ4TDZWWSZlbmNyeXB0ZWRBZElkPUExMDM3MTk0UTQxOTI3TVVWVktJJndpZGdldE5hbWU9c3BfbXRmJmFjdGlvbj1jbGlja1JlZGlyZWN0JmRvTm90TG9nQ2xpY2s9dHJ1ZQ==).

I made a little tap based on it because it is simple and it should be watertight.                 
If it is not working -> just buy the tap.

If you want, all the codes are [available on my gitlab]().

Basic versions:  

* lil_tap.scad: it is just 2 pipes and it cannot be closed.           
 ![lil tap](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/lil_tap1.jpg)           
* lil_tap2.scad: the side pipe is bigger to ease the printing as it touch the tray when the tap is placed on the side.                           
 ![lil tap2](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/lil_tap2.jpg)         

Then I added a way to close it.         

* lil_tap3print.scad: the principle is that when you pull the trigger, the liquid is flowing and when you push the trigger, liquid is blocked.                       
  The pressure of the liquid needs to be low so that the liquid does not push itself the trigger from the interior -> test the tap.

  ![lil tap 3 strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/lil_tap3_strip.jpg)

  I tried to print it on the side and vertically:       

  * Vertically: it was the first time I used support.          
  I required support until the 98th layer to be able to print the piece correctly without inner support that (I think) would be impossible to remove.                
   Like always: 25% infill, honeycomb (because why change ?).                  
   The brim option does not change anything because of the support option.             
   I used a screwdriver to remove the supports and I broke my piece trying to make it work so I changed the code to have more space between the 2 parts and I printed again -> support until 126th layer.
   **Result**: the inner supports cannot be removed so wrong way.      

  * On the side: it is not working.              
     Both parts are too close, the tap is too small  

* lil_tap4.scad: bigger.       

  ![lil_tap4 strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/lil_tap4_strip.jpg)        

  Printed on the side: may need a support for the extremity of the interior mecanism (like my ovnis with support).
  I used a screwdriver to detach the inner mecanism from the exterior body.               
  **Result**: SUCCESS ! but not well printed -> I added some glue to fill the spaces.         
  **Test**: FAIL ... I failed one variable.       

* lil_tap4real.scad: with a support, the wrong variable was the length between the little and the big radius of the interior mecanism, now it is correct.           
  Printing: 1 mm of brim is too little and the piece moved ... -> 2 mm of brim.             
  The support is too well attached but that is not a problem.         
  The inner blocker is not well printed enough to block the flow -> the inner blocker need to touch the inner part of the body to be well printed and not overhang.

  **Result**: I did not print the new version because of time constrain but I would put varnish on it against spaces.

  Here is the code:   

  ![lil tap 4real strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/lil_tap4real_strip.jpg)

```
  /*
FILE   : lil_tap4real.scad

 AUTHOR : Nathalie Wéron

 DATE   : 2022-05-31
MODIFIED : 2022-06-01

 LICENSE : Creative Commons Attribution-ShareAlike 4.0 International [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).
//*/

 $fn = 200;
L = 25; // total length of the body: the distance between the 2.5 mm radius and the 4 mm radius is 25 mm.
LL = 9.45; // length of the conic part of the body: (25 mm/2) - radius2
lL = 7; // lentgth of the side hole for the liquid to flow
radius = 3.5; // little radius of the body
Radius = 6; // big radius of the body, 3.067 mm radius 9.45 mm further than the little radius
diff = 0.5; // difference between the exterior and the interior of the body, 0.5 is the minimum to print
radius2 = 6; // needs to be the closest and below Radius
thick = 0.5; // thickness of the little stop
rint = 4.33; // little radius of the interior mecanism
Rint = 4.85; // big radius of the interior mecanism, 3.3 mm further than the 2.2 mm radius
lint = 3.85; // distance between the little and the big radius

 //Code:
difference(){
union (){

  difference(){ // exterior
    union (){
        cylinder(LL, r1 = radius, r2 = Radius);
        translate([0,0,15])
            rotate([0,90,0])
                cylinder(lL, r = radius2);
        translate([0,0,LL])
            cylinder(L-LL, r = Radius);
    }
    cylinder (LL, r1 = radius-diff, r2 = Radius-diff);
    translate([0,0,15])
        rotate([0,90,0])
            cylinder(lL, r = radius2-diff);
    translate([0,0,LL])
            cylinder(L-LL, r = Radius-diff);
}

 difference(){ // little stop
    translate([0,0,L-thick])
        cylinder(thick, r = Radius);
    translate([-Radius,-Radius,L-thick])
        cube([Radius+0.25,Radius*2,thick]);
}

 difference(){
    union(){
        translate([0,5.5-4.85,7]){ // interior mecanism to close the tap
        translate([0,0,3.33])
            cylinder (lint, r1 = rint, r2 = Rint);
        difference(){
            translate([0,0,3.33+lint])
                cylinder (L, r = Rint-0.5);
            translate([0,-(Rint),L-(L-(lint+3.33))])
                cube([Rint,(Rint)*2,L-(lint+3)]); // L-(LL+3.33) normally -> L-(LL+3)
        }
        }
    }

 }

   //support
difference(){
    translate([-(Rint-0.5),0,10.33+lint+L-(lint+3)])
        cube([(Rint-0.5)*2, Radius, lint+3]);
/*/
    translate([0,-0.5,10.33+lint+L-(lint+3)])
        cylinder(lint+3, r = Rint+0.1);
/*/
}

 }

 /*
// cut to see the interior:
translate([-30,-Radius,0])
    cube([30,30,50]);
/*/
}
```

## 3.The simple Norwegian kettle        
As an insolation for the bucket would help to reach objective temperatures, I though about the Norwegian kettle while searching in the Low-tech Lab sheets. I already knew about the Norwegian kettle but I never thought that I would use it for a composting bucket. The principle of this low-tech is to keep the heat of the cooking pot in an insulated box but I would only use a simpler version of it.

### 3.1.Materials           

* 1 survival blanket: 4€04

* 1 towel or blanket or duvet or other: free because from your house                 
  I used a towel then a blanket.

* 1 something to keep both layers in place                
  I used a ribbon.

### 3.2.Instructions         

You basically have to put the bucket in the survival blanket then in the other layer.

1. Cut in half the survival blanket.               
  The survival blanket is too big. I counted 10 little rectangles in both parts.

 ![survival blanket strip](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/blanket_strip.jpg)          

2. Put the temperature sensor in the bucket content near the edge and some cm deep.                 
  The thermometre components can be placed on the ground for the moment.

  ![placing the thermometre in the bucket](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bucket&thermometre.jpg)

3. Put the bucket in the survival blanket with the golden side to the exterior.                 
  It is the silver side that reflects thermal radiations.             
  You can wrap all the bucket in the survival blanket. The lid is just placed over the bucket as oxygen is needed during composting and the thermometre sensor wire needs to go out the bucket.

  ![bucket in survival blanket](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/bucket_blanket.jpg)

3. Put the towel around the previous construction and fix it.          
  Now you can place the thermometre components over the lid and open a way in the layers for oxygen to enter the bucket.

  ![cute towel](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/cute_towel.jpg)               
  ![opening for oxygen](https://gitlab.com/fablab-ulb/enseignements/2021-2022/fabzero-experiments/students/nathalie.weron/-/raw/main/docs/Final-project/Images/4.Prototyping/oxygen.jpg)

  Later I completely closed the opening to keep more heat. More tests are needed to know what is the best.

### 3.3.Result           
I did not test the "Norwegian kettle" before using it with the bucket so I do not really know whether it is working or not. I have faith but I should test it.             

## Reference          

[^1]: C. Niwagaba, M. Nalubega, B. Vinnerås, C. Sundberg, H. Jönsson, Bench-scale composting of source-separated human faeces for sanitation, Waste Management, Volume 29, Issue 2, 2009, Pages 585-589, ISSN 0956-053X, https://doi.org/10.1016/j.wasman.2008.06.022. (https://www.sciencedirect.com/science/article/pii/S0956053X08001980).
